#ifndef __MERLINCACHE_H__
#define __MERLINCACHE_H__

#include "Mantra.h"
#include "TreeBasics.h"

class MerlinCache
   {
   public:
      MerlinCache();
      ~MerlinCache();

      void OpenCache(Mantra & m);
      void CloseCache();

      bool RetrieveFromCache(Mantra & m, BasicTree & tree, String & marker);
      void SaveToCache(Mantra & m, BasicTree & tree, String & marker);

      static String directory;

      static void FreeBuffers() { BasicTree::FreeBuffers(); }

   private:
      FILE * indexFile;
      FILE * dataFile;

      StringIntHash markers;
      String tag;

      bool isActive;

      bool IndexMatches(Mantra & m);
   };


#endif
