#ifndef __MERLINPDF_H__
#define __MERLINPDF_H__

#include "PDF.h"
#include "PDFlinechart.h"

class MerlinPDF : public PDF
   {
   public:
      PDFLineChart chart;
      Vector & positions;

      MerlinPDF(Vector & plotLocations);
      ~MerlinPDF();

      void OpenFile(const char * filename);
      void CloseFile();

      void PrepareChart(int series = 1);
      void DrawChart();

      void SelectChromosome(int chr);
      void SelectChromosomeX();

      Vector x;
      Matrix y;

   private:
      String filename;
      String chromosome;

   };

#endif

