#ifndef __UNKNOWN_H__
#define __UNKNOWN_H__

#include "IntArray.h"
#include "StringMap.h"

#define U_GRAPH      0
#define U_MISSING    1
#define U_INVALID    2

class Unknown
   {
   public:
      int type;
      int marker;

      Unknown()
         {
         marker = -1;
         type = U_INVALID;
         }

      virtual ~Unknown() {}
   };

class MissingAllele : public Unknown
   {
   public:
      int haplotype;

      MissingAllele()
         { type = U_MISSING; };

      virtual ~MissingAllele() {}
   };

class AlleleGraph : public Unknown
   {
   public:
      IntArray haplotypes;
      IntArray alleles;

      AlleleGraph()
         { type = U_GRAPH; }

      virtual ~AlleleGraph() {}

      void Append(int haplo, int allele1, int allele2)
         {
         haplotypes.Push(haplo);
         alleles.Push(allele1);
         alleles.Push(allele2);
         }
   };

class SetOfUnknowns : public StringMap
   {
   public:
      Unknown * GetUnknown(int index)
         { return (Unknown *) Object(index); };

      MissingAllele * GetMissing(const ::String & name);
      AlleleGraph * GetGraph(const ::String & name);

      ~SetOfUnknowns();
      
   private:
      static void * create_missing();
      static void * create_graph();
   };

#endif

